<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from xml/schema/CRM/Core/RecurringEntity.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:1f197a5848ca641233a99582e055dfb2)
 */

/**
 * Database access object for the RecurringEntity entity.
 */
class CRM_Core_DAO_RecurringEntity extends CRM_Core_DAO {

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_recurring_entity';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * @var int
   */
  public $id;

  /**
   * Recurring Entity Parent ID
   *
   * @var int
   */
  public $parent_id;

  /**
   * Recurring Entity Child ID
   *
   * @var int
   */
  public $entity_id;

  /**
   * Physical tablename for entity, e.g. civicrm_event
   *
   * @var string
   */
  public $entity_table;

  /**
   * 1-this entity, 2-this and the following entities, 3-all the entities
   *
   * @var bool
   */
  public $mode;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_recurring_entity';
    parent::__construct();
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('ID'),
          'required' => TRUE,
          'where' => 'civicrm_recurring_entity.id',
          'table_name' => 'civicrm_recurring_entity',
          'entity' => 'RecurringEntity',
          'bao' => 'CRM_Core_BAO_RecurringEntity',
          'localizable' => 0,
        ],
        'parent_id' => [
          'name' => 'parent_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Parent ID'),
          'description' => ts('Recurring Entity Parent ID'),
          'required' => TRUE,
          'where' => 'civicrm_recurring_entity.parent_id',
          'table_name' => 'civicrm_recurring_entity',
          'entity' => 'RecurringEntity',
          'bao' => 'CRM_Core_BAO_RecurringEntity',
          'localizable' => 0,
        ],
        'entity_id' => [
          'name' => 'entity_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Entity ID'),
          'description' => ts('Recurring Entity Child ID'),
          'where' => 'civicrm_recurring_entity.entity_id',
          'table_name' => 'civicrm_recurring_entity',
          'entity' => 'RecurringEntity',
          'bao' => 'CRM_Core_BAO_RecurringEntity',
          'localizable' => 0,
        ],
        'entity_table' => [
          'name' => 'entity_table',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => ts('Entity Table'),
          'description' => ts('Physical tablename for entity, e.g. civicrm_event'),
          'required' => TRUE,
          'maxlength' => 64,
          'size' => CRM_Utils_Type::BIG,
          'where' => 'civicrm_recurring_entity.entity_table',
          'table_name' => 'civicrm_recurring_entity',
          'entity' => 'RecurringEntity',
          'bao' => 'CRM_Core_BAO_RecurringEntity',
          'localizable' => 0,
        ],
        'mode' => [
          'name' => 'mode',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => ts('Cascade Type'),
          'description' => ts('1-this entity, 2-this and the following entities, 3-all the entities'),
          'required' => TRUE,
          'where' => 'civicrm_recurring_entity.mode',
          'default' => '1',
          'table_name' => 'civicrm_recurring_entity',
          'entity' => 'RecurringEntity',
          'bao' => 'CRM_Core_BAO_RecurringEntity',
          'localizable' => 0,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Return a mapping from field-name to the corresponding key (as used in fields()).
   *
   * @return array
   *   Array(string $name => string $uniqueName).
   */
  public static function &fieldKeys() {
    if (!isset(Civi::$statics[__CLASS__]['fieldKeys'])) {
      Civi::$statics[__CLASS__]['fieldKeys'] = array_flip(CRM_Utils_Array::collect('name', self::fields()));
    }
    return Civi::$statics[__CLASS__]['fieldKeys'];
  }

  /**
   * Returns the names of this table
   *
   * @return string
   */
  public static function getTableName() {
    return self::$_tableName;
  }

  /**
   * Returns if this table needs to be logged
   *
   * @return bool
   */
  public function getLog() {
    return self::$_log;
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'recurring_entity', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'recurring_entity', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
